// PLSTDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "PLST.h"

#include "ce2data.h"
#include "partlist.h"

#include "PLSTDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static const char s_szRegSectionRFL[]="Recent File List";
static const char s_szRegSectionOption[]="Option";
static const char s_szRegEntryIsCsv[]="CsvFile";
static const char s_szRegEntryNameSort[]="SortByName";
static const char s_szRegEntryPreSuf[]="DivNumber";
static const char s_szRegEntryPosition[]="Position";
static const char s_szRegEntryNoDuplicate[]="NoDuplicate";
static const char* s_szListFileExt[]={".LST",".CSV"};

//////////////////////////////////////////////////
// o̓t@C쐬B
// t@Cgq邾B
static CString s_GetOutPutPath(LPCSTR szPath,LPCSTR szNewExt)
{
	char szFullPath[_MAX_PATH];
	char szDrive[_MAX_DRIVE];
	char szDir[_MAX_DIR];
	char szName[_MAX_FNAME];
	char szExt[_MAX_EXT];
	const char* pszExt;
	_splitpath(szPath,szDrive,szDir,szName,szExt);
	if(szName[0]==0) return CString("");
	if(!lstrcmp(szExt,szNewExt)) pszExt=".$$$";
	else pszExt=szNewExt;
	_makepath(szFullPath,szDrive,szDir,szName,pszExt);
	return CString(szFullPath);
}



/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐𐶐I[o[Ch܂
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPLSTDlg _CAO

CPLSTDlg::CPLSTDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPLSTDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPLSTDlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bSetOutputListRect=FALSE;
}

void CPLSTDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPLSTDlg)
		// : ̏ꏊɂ ClassWizard ɂ DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPLSTDlg, CDialog)
	//{{AFX_MSG_MAP(CPLSTDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_BUTTON_REF, OnButtonRef)
	ON_BN_CLICKED(IDC_CHECK_CSV, OnCheckCsv)
	ON_CBN_EDITCHANGE(IDC_COMBO_FILE, OnEditchangeComboFile)
	ON_CBN_SELENDOK(IDC_COMBO_FILE, OnSelendokComboFile)
	ON_BN_CLICKED(ID_ABOUT, OnAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPLSTDlg bZ[W nh
BOOL CPLSTDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	//CMenu* pSysMenu = GetSystemMenu(FALSE);
	//CString strAboutMenu;
	//strAboutMenu.LoadString(IDS_ABOUTBOX);
	//if (!strAboutMenu.IsEmpty())
	//{
	//	pSysMenu->AppendMenu(MF_SEPARATOR);
	//	pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	//}
	
	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	HICON hIcon=AfxGetApp()->LoadIcon(IDI_SMALL);
	SetIcon(hIcon, FALSE);		// ACRݒ
	// TODO: ʂȏs͂̏ꏊɒǉĂB

	/////////////////////////////////////////////////////
	//  R{{bNXւ̒l̐ݒ
	char szEntry[32];
	CString strPath;
	int i;
	CComboBox* pCombo;
	pCombo=(CComboBox*)GetDlgItem(IDC_COMBO_FILE);
	for(i=0;i<RFL_COUNT;i++){
		wsprintf(szEntry,"File%d",i);
		strPath=AfxGetApp()->GetProfileString(s_szRegSectionRFL,szEntry);
		if(strPath.IsEmpty())break;
		pCombo->AddString(strPath);
	}
	if(!m_strCmdLine.IsEmpty()){
		pCombo->SetWindowText(m_strCmdLine);
	}else{
		if(pCombo->GetCount()>0){
			pCombo->SetCurSel(0);
			pCombo->SetEditSel(-1,-1);
		}
	}

	int nCheck;
	CButton* pCheck;
	//CSVw
	nCheck=AfxGetApp()->GetProfileInt(s_szRegSectionOption,s_szRegEntryIsCsv,0);
	if(nCheck) nCheck=1;
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_CSV);
	pCheck->SetCheck(nCheck);
	//vtBbNXƃTtBbNX𕪂
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_PRE_SUF);
	if(!nCheck){	//CSV[ĥƂ̓vtBbNXƃTtBbNX𕪂郂[h֎~
		pCheck->SetCheck(0);
		pCheck->EnableWindow(FALSE);
	}else{
		pCheck->EnableWindow(TRUE);
		nCheck=AfxGetApp()->GetProfileInt(s_szRegSectionOption,s_szRegEntryPreSuf,0);
		if(nCheck) nCheck=1;
		pCheck=(CButton*)GetDlgItem(IDC_CHECK_PRE_SUF);
		pCheck->SetCheck(nCheck);
	}
	//Oɂ\[g
	nCheck=AfxGetApp()->GetProfileInt(s_szRegSectionOption,s_szRegEntryNameSort,0);
	if(nCheck) nCheck=1;
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_SORT_NAME);
	pCheck->SetCheck(nCheck);
	//ʒu
	nCheck=AfxGetApp()->GetProfileInt(s_szRegSectionOption,s_szRegEntryPosition,0);
	if(nCheck) nCheck=1;
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_POSITION);
	pCheck->SetCheck(nCheck);
	//d`FbN
	nCheck=AfxGetApp()->GetProfileInt(s_szRegSectionOption,s_szRegEntryNoDuplicate,0);
	if(nCheck) nCheck=1;
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_NODUPLICATE);
	pCheck->SetCheck(nCheck);


	SetListFileName();

	////////////////////////////////////////////////////////////////
	//AEgvbg̃j^p̃Xg{bNX̃tHgݒ
	m_font.CreateFont( 16,					//nHeight
					   0,					//nWidth
					   0,					//nEscapement,
					   0,					//nOrientation,
					   FW_DONTCARE,			//nWeight
					   0,					//bItalic
					   0,					//bUnderline
					   0,					//cStrikeOut
					   SHIFTJIS_CHARSET,	//nCharSet
					   OUT_TT_PRECIS,		//nOutPrecision
					   CLIP_DEFAULT_PRECIS,	//nClipPrecision
					   DEFAULT_QUALITY,		//nQuality
					   FIXED_PITCH|TMPF_TRUETYPE|FF_DONTCARE,//nPitchAndFamily
					   "lr SVbN"		//lpszFacename 
					);
	CListBox* pListBox=(CListBox*)GetDlgItem(IDC_LIST_OUTPUT);
	pListBox->SetFont(&m_font);

	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CPLSTDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
//	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
//	{
//		CAboutDlg dlgAbout;
//		dlgAbout.DoModal();
//	}
//	else
//	{
		CDialog::OnSysCommand(nID, lParam);
//	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CPLSTDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CPLSTDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


////////////////////////////////////////////////////////////////
//  WM_SIZE
//
//C̃EChEɍ킹ăAEgvbg̃j^pXg{bNX
//̃TCYςB
void CPLSTDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	TRACE("WM_SIZE\n");
	if(m_bSetOutputListRect){
		CRect rc;
		GetClientRect(&rc);
		rc.left	 =m_rcOutputList.left;
		rc.top	 =m_rcOutputList.top;
		rc.right -=m_nOutputListBoxRight;
		rc.bottom-=m_nOutputListBoxBottom;
		CListBox* pList=(CListBox*)GetDlgItem(IDC_LIST_OUTPUT);
		pList->MoveWindow(&rc);
	}
}


void CPLSTDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	TRACE("WM_SHOWWINDOW\n");
	if(!m_bSetOutputListRect){
		CListBox* pList=(CListBox*)GetDlgItem(IDC_LIST_OUTPUT);
		pList->GetWindowRect(&m_rcOutputList);
		ScreenToClient(&m_rcOutputList);
		TRACE("%d,%d,%d,%d\n",m_rcOutputList.left,m_rcOutputList.top,m_rcOutputList.right,m_rcOutputList.bottom);
		CRect rc;
		GetClientRect(&rc);
		m_nOutputListBoxRight=rc.right-m_rcOutputList.right;
		m_nOutputListBoxBottom=rc.bottom-m_rcOutputList.bottom;
		TRACE("%d,%d\n",m_nOutputListBoxRight,m_nOutputListBoxBottom);
		m_bSetOutputListRect=TRUE;
	}
}

/////////////////////////////////////////////////////
// OnCancel() uI{^ṽCxgnh
//
//  t@C̗ƃIvVWXgɋL^B
void CPLSTDlg::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB

	/////////////////////////////////////////////////////
	//  R{{bNX烌WXgւ̒l̐ݒ
	char szEntry[32];
	CString strPath;
	int i,nComboCount;
	CComboBox* pCombo;
	pCombo=(CComboBox*)GetDlgItem(IDC_COMBO_FILE);
	nComboCount=pCombo->GetCount();
	for(i=0;i<RFL_COUNT;i++){
		wsprintf(szEntry,"File%d",i);
		if(i<nComboCount){
			pCombo->GetLBText(i,strPath);
			AfxGetApp()->WriteProfileString(s_szRegSectionRFL,szEntry,strPath);
		}else{
			AfxGetApp()->WriteProfileString(s_szRegSectionRFL,szEntry,"");
		}
	}
	
	/////////////////////////////////////////////////////
	//  `FbN{bNX烌WXgւ̒l̐ݒ
	int nCheck;
	CButton* pCheck;
	//CSVw
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_CSV);
	nCheck=pCheck->GetCheck();
	AfxGetApp()->WriteProfileInt(s_szRegSectionOption,s_szRegEntryIsCsv,nCheck);

	//Oɂ\[g
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_SORT_NAME);
	nCheck=pCheck->GetCheck();
	AfxGetApp()->WriteProfileInt(s_szRegSectionOption,s_szRegEntryNameSort,nCheck);

	//vtBbNXƃTtBbNX𕪂
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_PRE_SUF);
	nCheck=pCheck->GetCheck();
	AfxGetApp()->WriteProfileInt(s_szRegSectionOption,s_szRegEntryPreSuf,nCheck);

	//ʒu
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_POSITION);
	nCheck=pCheck->GetCheck();
	AfxGetApp()->WriteProfileInt(s_szRegSectionOption,s_szRegEntryPosition,nCheck);

	//d`FbN
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_NODUPLICATE);
	nCheck=pCheck->GetCheck();
	AfxGetApp()->WriteProfileInt(s_szRegSectionOption,s_szRegEntryNoDuplicate,nCheck);

	CDialog::OnCancel();
}

/////////////////////////////////////////////////////
// OnButtonRef() uQƃ{^ṽCxgnh
//
void CPLSTDlg::OnButtonRef() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	CFileDialog dlg(TRUE,				//I[v_CAO
					NULL,				//gqtȂꍇ̃ftHg
					"*.CE2",			//t@C
					OFN_HIDEREADONLY|OFN_FILEMUSTEXIST,
					"CE Library(*.ce2)|*.CE2||",	//tB^
					this);				//eEChE
	if(IDOK==dlg.DoModal()){			//t@C_CAO̎s
		CComboBox* pCombo;
		pCombo=(CComboBox*)GetDlgItem(IDC_COMBO_FILE);
		CString strPath=CString(dlg.m_ofn.lpstrFile);
		pCombo->SetWindowText(strPath);
		SetListFileName();
	}

}


/////////////////////////////////////////////////////
// OnOK() us{^ṽCxgnh
//
//  (1)R{{bNX̃GfBbgRg[t@C𓾂
//  (2)CCe2DataIuWFNg m_pCe2Data  new B
//  (3)t@Cǂݍ
//  (4)PARTLIST֐Ă
//  (6)Xgt@Cۑ
//  (7)m_pCe2Data  delete B
void CPLSTDlg::OnOK() 
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
		// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ
	TRACE("OnOK()\n");

	////////////////////////////////////////////////////////////
	//R{{bNXt@C̊l
	CComboBox* pCombo;
	CString strPath;
	pCombo=(CComboBox*)GetDlgItem(IDC_COMBO_FILE);
	//pCombo->SetEditSel(-1,-1);
	pCombo->GetWindowText(strPath);
	if(strPath.IsEmpty()) return;		//t@Cݒ肳ĂȂΖ߂
	CString strPathOutput;
	GetDlgItemText(IDC_EDIT_LISTFILE,strPathOutput);
	if(strPathOutput.IsEmpty()) return;	//t@Cݒ肳ĂȂΖ߂
	
	///////////////////////////////////////////////////////////
	// R{{bNX̃Xg{bNX炢ƑΏۃt@C
	CString strComboList;
	int nmax=pCombo->GetCount();
	int i;
	for(i=nmax-1;i>=0;i--){
		pCombo->GetLBText(i,strComboList);
		if(strComboList==strPath) pCombo->DeleteString(i);
	}
	
	////////////////////////////////////////////////////
	// o̓t@CJ
	CStdioFile fileOutput;
	if(fileOutput.Open(strPathOutput,
					CFile::modeCreate|CFile::modeWrite|
					CFile::typeText|CFile::shareExclusive
				)==FALSE)
	{//t@C̃I[vɎs
		CString rMsg;
		AfxFormatString1(rMsg,IDS_FILEOPENERROR,strPathOutput);	//bZ[W 
		AfxMessageBox(rMsg,MB_OK);							//bZ[W{bNX\
		return;
	}


	////////////////////////////////////////////////////
	// }ʃf[^NX m_pCe2Data new 
	m_pCe2Data=new CCe2Data;
	if(m_pCe2Data->ReadFile(strPath)==FALSE)
	{//t@C̓ǂݍ݂Ɏs
		delete m_pCe2Data;
		CString rMsg;
		AfxFormatString1(rMsg,IDS_FILEREADERROR,strPath);	//bZ[W 
		AfxMessageBox(rMsg,MB_OK);							//bZ[W{bNX\
		pCombo->SetWindowText("");
		SetDlgItemText(IDC_EDIT_LISTFILE,"");
		return;
	}
	TRACE("Part count : %d\n",m_pCe2Data->m_listPart.GetCount());
	
	//IvV`FbN{bNXǂݏo
	BOOL bCsv,bSortName,bPreSuf,bPosition,bNoDuplicate;
	CButton* pCheck;
	//CSVw
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_CSV);
	bCsv=pCheck->GetCheck();
	//Oɂ\[g
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_SORT_NAME);
	bSortName=pCheck->GetCheck();
	//vtBbNXƃTtBbNX𕪂
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_PRE_SUF);
	bPreSuf=pCheck->GetCheck();
	//ʒu
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_POSITION);
	bPosition=pCheck->GetCheck();
	//d`FbN
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_NODUPLICATE);
	bNoDuplicate=pCheck->GetCheck();

	CListBox* pListBox=(CListBox*)GetDlgItem(IDC_LIST_OUTPUT);
	pListBox->ResetContent();


	if(FALSE==g_PartList(&(m_pCe2Data->m_listPart),
				&fileOutput,
				pListBox,
				bCsv,
				bSortName,
				bPreSuf,
				bPosition,
				bNoDuplicate))
	{//t@C݂̏Ɏs
		CString rMsg;
		AfxFormatString1(rMsg,IDS_FILEWRITEERROR,strPathOutput);//bZ[W 
		AfxMessageBox(rMsg,MB_OK);								//bZ[W{bNX\
		return;
	}


	////////////////////////////////////////////////////
	// }ʃf[^NX m_pCe2Data delete 
	delete m_pCe2Data;
	
	pCombo->InsertString(0,strPath);//ƃt@CR{{bNX̃gbvɓo^
	while(pCombo->GetCount()>RFL_COUNT) pCombo->DeleteString(RFL_COUNT);//镪폜
	pCombo->SetWindowText(strPath); //ƃt@CR{{bNX̃GfBbgRg[ɃZbg
	
	AfxMessageBox(IDS_FINISHED,MB_OK|MB_ICONINFORMATION);		//IbZ[W{bNX\

	//CDialog::OnOK();
}

void CPLSTDlg::OnCheckCsv() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	SetListFileName();
	BOOL bCheck;
	//CSV[ĥƂ́AvtBbNXƃTtBbNX𕪂郂[h֎~
	CButton* pCheck=(CButton*)GetDlgItem(IDC_CHECK_CSV);
	bCheck=pCheck->GetCheck();	//CSṼ`FbNԂ𓾂
	pCheck=(CButton*)GetDlgItem(IDC_CHECK_PRE_SUF);
	if(!bCheck){
		pCheck->SetCheck(0);
		pCheck->EnableWindow(FALSE);
	}else{
		pCheck->EnableWindow(TRUE);
	}
}

/////////////////////////////////////////////////////////////
//   o̓t@Cݒ肷
//
//  }ʃt@C̃GfBbgRg[ɕύXꂽƂ
//  Xg{bNXŕύXƂ 
//
//  o̓t@CZbg
void CPLSTDlg::SetListFileName(LPCSTR szSrcFile)
{
	int nCsv; //CSVt@CȂPBłȂ΂OB
	CString strFileName;
	CButton* pCheck=(CButton*)GetDlgItem(IDC_CHECK_CSV);
	if(pCheck->GetCheck()) nCsv=1; else nCsv=0;
	if(szSrcFile==NULL){
		CComboBox* pCombo=(CComboBox*)GetDlgItem(IDC_COMBO_FILE);
		pCombo->GetWindowText(strFileName);
	}else{
		strFileName=CString(szSrcFile);
	}
	strFileName=s_GetOutPutPath(strFileName,s_szListFileExt[nCsv]);
	SetDlgItemText(IDC_EDIT_LISTFILE,strFileName);
}

//  }ʃt@C̃GfBbgRg[ɕύXꂽƂ
void CPLSTDlg::OnEditchangeComboFile() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	SetListFileName();
}

//  Xg{bNXŕύXƂ 
void CPLSTDlg::OnSelendokComboFile() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	TRACE("CPLSTDlg::OnSelendokComboFile()\n");
	CString strFileName; 
	CComboBox* pCombo=(CComboBox*)GetDlgItem(IDC_COMBO_FILE);
	int nIndex=pCombo->GetCurSel();
	if(nIndex!=CB_ERR)	pCombo->GetLBText(nIndex,strFileName);
	SetListFileName(strFileName);
}

void CPLSTDlg::OnAbout() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
}
